/*!
 * @file    uwb_SmartField_core.h
 * @author  Kryštof Vaněk <krystof.vanek@gmail.com>
 * @version 3.0
 * @date    2021-02-15
 * @brief   SmartField computation core
 *
 * @attention <h2><center>&copy; Copyright (c) 2021 University of West Bohemia in Pilsen All rights reserved.</center></h2>
 * @attention <h2><center>Use of this source code without author permission and license agreement is prohibited. For license agreement contact the author.</center></h2>
 * @attention <h2><center>Tento zdrojový kód nelze využívat bez souhlasu autora a dohodě o licenčních podmínkách. Pro případné licencování kontaktujte autora.</center></h2>
 *
 * Developed by:<br>
 * University of West Bohemia<br>
 * Department of Technologies and Measurement<br>
 * www.zcu.cz
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
 * INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE CONTRIBUTORS OR COPYRIGHT HOLDERS
 * BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
 * TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE
 * OR THE USE OR OTHER DEALINGS WITH THE SOFTWARE.
 */


#ifndef _UWB_SMARTFIELD_CORE_H_
#define _UWB_SMARTFIELD_CORE_H_

#ifdef __cplusplus
extern "C" {
#endif

/**
 * @defgroup SmartField_Core SmartField Core
 * @brief SmartField Computation core module
 * @{
 */

extern SmartField_Status_t	SmartField_Core_SampleData		(void);
extern void					SmartField_Core_DumpRawData		(void (*callbackPtr)(uint8_t* pData, uint32_t dataLength));
extern void					SmartField_Core_ProcessData		(SmartField_Settings_t* settings);
extern void					SmartField_Core_ProcessData_DFT	(SmartField_Settings_t* settings);
extern void					SmartField_Core_DumpData		(void (*callbackPtr)(float* voltage, float* current, uint32_t dataLength));
extern SmartField_Result_t*	SmartField_Core_GetResult		(void);

/**
 * @}
 */

#ifdef __cplusplus
}
#endif

#endif /* _UWB_SMARTFIELD_CORE_H_ */
